﻿/**
* MikuMikuDance VMD形式の再生制御のインターフェース
*
* @author b2ox
*/
package org.b2ox.flash3d.MikuMikuDance
{
	import org.libspark.betweenas3.tweens.ITween;

	/**
	 * モーションの再生制御
	 */
	public interface IVMDController
	{
		//-------------------------------------------------
		// 再生用のAPI
		/**
		 * ポーズのリセット、フレーム数更新、パラメータ更新、ポーズへの適用を行うtween.
		 * counterTween, updaterTweenなどの並列合成になっている
		 */
		function get tween():ITween;
		/**
		 * フレーム数の更新のみを行うtween
		 */
		function get counterTween():ITween;
		/**
		 * パラメータの更新のみを行うtween
		 */
		function get updaterTween():ITween;

		function get looping():Boolean;
		function set looping(loop:Boolean):void;
		function play():void;
		function stop():void;
		function togglePause():void;
		function gotoAndPlay(pos:Number):void;
		function gotoAndStop(pos:Number):void;
		function get playing():Boolean;

		function update():void;
		function resetParams():void;
		function applyPose():void;
		function applyCurrent():void;
	}
}
